"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const useFetch_1 = __importDefault(require("./useFetch"));
class BackendCall {
    constructor(baseApiUrl, defaultHeaders = {}, defaultSuccessFunction = (res) => res, defaultErrorFunction = (err) => err) {
        this.baseApiUrl = baseApiUrl;
        this.defaultHeaders = defaultHeaders;
        this.defaultSuccessFunction = defaultSuccessFunction;
        this.defaultErrorFunction = defaultErrorFunction;
    }
    postData(endPoint, bodyDefault, queryDefault) {
        return (0, useFetch_1.default)(endPoint, 'POST', bodyDefault, queryDefault, this.baseApiUrl, this.defaultHeaders, this.defaultSuccessFunction, this.defaultErrorFunction);
    }
    getData(endPoint, queryDefault) {
        return (0, useFetch_1.default)(endPoint, 'GET', undefined, queryDefault, this.baseApiUrl, this.defaultHeaders, this.defaultSuccessFunction, this.defaultErrorFunction);
    }
    updateData(endPoint, bodyDefault, queryDefault) {
        return (0, useFetch_1.default)(endPoint, 'PUT', bodyDefault, queryDefault, this.baseApiUrl, this.defaultHeaders, this.defaultSuccessFunction, this.defaultErrorFunction);
    }
    patchData(endPoint, bodyDefault, queryDefault) {
        return (0, useFetch_1.default)(endPoint, 'PATCH', bodyDefault, queryDefault, this.baseApiUrl, this.defaultHeaders, this.defaultSuccessFunction, this.defaultErrorFunction);
    }
    deleteData(endPoint, bodyDefault, queryDefault) {
        return (0, useFetch_1.default)(endPoint, 'DELETE', bodyDefault, queryDefault, this.baseApiUrl, this.defaultHeaders, this.defaultSuccessFunction, this.defaultErrorFunction);
    }
    custom(endPoint, method, bodyDefault, queryDefault) {
        return (0, useFetch_1.default)(endPoint, method, bodyDefault, queryDefault, this.baseApiUrl, this.defaultHeaders, this.defaultSuccessFunction, this.defaultErrorFunction);
    }
}
exports.default = BackendCall;
//# sourceMappingURL=BackendCall.js.map